#ifndef __dialog_h__
#define __dialog_h__
#include "init.h"

#define back_color makecol (123, 64, 43)
#define caption_color makecol (12, 59, 164)
#define active_color makecol (12, 59, 255)
#define border_color makecol (255, 255, 255)
#define font_color makecol (255, 255, 255)

class button {
 private:
  int id;
  int left;
  int top;
  int width;
  int height;
  char caption[MAX_LENGTH];
  bool active;
  BITMAP * button_bmp;
 public:
  button ();
  void set_button (int new_id, int new_left, int new_top, int new_width, int new_height, char * new_caption);
  void set_caption (char * new_caption);
  void set_active ();
  void set_inactive ();
  bool get_active ();
  int get_id ();
  void draw (BITMAP * output);
};

class label {
 private:
  int id;
  int left;
  int top;
  int width;
  int height;
  char caption[MAX_LENGTH];
  BITMAP * label_bmp;
 public:
  label ();
  void set_label (int new_id, int new_left, int new_top, int new_width, int new_height, char * new_caption);
  void set_caption (char * new_caption);
  int get_id ();
  void draw (BITMAP * output);
};

class dialog {
 private:
  int left;
  int top;
  int width;
  int height;
  int active;
  char caption[MAX_LENGTH];
  int buttons_count;
  button buttons[MAX_BUTTONS];
  int labels_count;
  label labels[MAX_BUTTONS];
  BITMAP * dialog_bmp;
 public:
  dialog ();
  void set_dialog (int new_left, int new_top, int new_width, int new_height, char * new_caption);
  void add_button (int new_id, int new_left, int new_top, int new_width, int new_height, char * new_caption);
  void add_label (int new_id, int new_left, int new_top, int new_width, int new_height, char * new_caption);
  void button_set_caption (int id, char * new_caption);
  void label_set_caption (int id, char * new_caption);
  int process_keys ();
  void update ();
  void draw (BITMAP * output);
};

#endif
