#ifndef __game_h__
#define __game_h__
#include "ship.h"
#include "molecule.h"
#include "jelly.h"

extern bool game_running;
extern bool game_over;
extern bool getready;
extern BITMAP * sideframe;
extern BITMAP * meter;
extern BITMAP * health;
extern BITMAP * multiplier;
extern MIDI * midi_music;
extern ship player;
extern int level;
extern int score;
extern float back_delta;

extern void game_pre_init ();
extern void game_init ();
extern void game_input ();
extern void game_pause ();
extern void game_process ();
extern void game_draw ();
extern void game_postgame ();
extern void game_terminate ();
extern void game_loop ();

extern void append_integer (char * string, int integer);
extern void draw_meter (BITMAP * output, BITMAP * input, int left, int top, int color, int percentile);
extern int test_collisions ();
extern void make_screen_shot ();

#endif
