#include <stdio.h>
#include <allegro.h>
#include "init.h"

int counter, fpscounter;
BITMAP * buffer;
BITMAP * back;
BITMAP * title;
bool sound_installed, disable_sound;
RGB pal[256];
DATAFILE * data_file;
FONT * tahoma;

int init_allegro () {
 allegro_init ();
 install_keyboard ();
 install_timer ();
 // install sound
 if (install_sound(DIGI_AUTODETECT, MIDI_AUTODETECT, "") == 0)
  sound_installed = true;

 disable_sound = true; // sound is default off
 // choosing graphics mode
 set_color_depth (24);
 if (set_gfx_mode (GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0)) {
  if (set_gfx_mode (GFX_AUTODETECT, 640, 480, 0, 0)) {
   printf ("No graphics could be initialised");
  }
 }
 buffer = create_bitmap (640, 480);
 text_mode (-1);
 return 0;
}

void count_fps () {
 fpscounter = counter;
 counter = 0;
}
END_OF_FUNCTION (count_fps);

// installs the fps counter
void install_fpscounter () {
 install_int (count_fps, 1000);
 LOCK_FUNCTION (count_fps);
 LOCK_VARIABLE (counter);
 LOCK_VARIABLE (fpscounter);
}

// used to init all stuf
int init_all () {
 sound_installed = false;
 disable_sound = false;

 init_allegro ();
 install_fpscounter ();

 set_window_title ("Fusion");
 set_window_close_button (0);
 data_file = load_datafile ("data/datafile.dat");

 back = load_pcx ("data/back_small.pcx", pal);
 tahoma = (FONT *) find_datafile_object(data_file, "tahoma")->dat;
 title = load_pcx ("data/title.pcx", pal);
 return 0;
}
