#include <stdio.h>
#include <allegro.h>
#include "init.h"
#include "jelly.h"

BITMAP * jelly_bmp;
jelly * gelpacks;
int gelpacks_count;
int gelpacks_max;
int gelpacks_step;

void init_jellys () {
 jelly_bmp = load_pcx ("data/jelly.pcx", pal);

 gelpacks_count = 0;
 gelpacks_max = 0;
 gelpacks_step = 1;
 gelpacks = (jelly *) malloc (gelpacks_max * sizeof (jelly));
}

void add_jelly (int new_pos_x, int new_pos_y) {
 gelpacks_count++;
 if (gelpacks_count > gelpacks_max) {
  gelpacks_max += gelpacks_step;
  gelpacks = (jelly *) realloc (gelpacks, gelpacks_max * sizeof (jelly));
 }
 gelpacks[gelpacks_count - 1].set_jelly (new_pos_x, new_pos_y);
}

void set_delta_jellys (float new_delta) {
 for (int i = 0; i < gelpacks_count; i++)
  gelpacks[i].set_delta (new_delta);
}

void set_speed_jellys (float new_speed) {
 for (int i = 0; i < gelpacks_count; i++)
  gelpacks[i].set_speed (new_speed);
}

void game_cycle_jellys () {
 for (int i = 0; i < gelpacks_count; i++)
  gelpacks[i].game_cycle ();
 for (int i = 0; i < gelpacks_count; i++) {
  if (!gelpacks[i].get_visible ()) {
   for (int j = i; j < gelpacks_count - 1; j++) {
    gelpacks[j] = gelpacks[j + 1];
   }
   gelpacks_count--;
  }
 }
}

void draw_jellys (BITMAP * output) {
 for (int i = 0; i < gelpacks_count; i++)
  gelpacks[i].draw (output);
}

void destroy_jellys () {
 // long live the jellypacks! FREE THEM!!!!
 free (gelpacks);
}

jelly::jelly () {
}

void jelly::set_jelly (float new_pos_x, float new_pos_y) {
 pos_x = new_pos_x;
 pos_y = new_pos_y;
}

void jelly::set_delta (float new_delta) {
 delta = new_delta;
}

void jelly::set_speed (float new_speed) {
 speed = new_speed;
}

void jelly::game_cycle () {
 pos_y -= delta * speed;
}

bool jelly::get_visible () {
 if (pos_y + 51 > 0 && pos_y - 51 < 480)
  return true;
 else
  return false;
}

void jelly::draw (BITMAP * output) {
 draw_sprite (output, jelly_bmp, int (pos_x) - 20, 480 - int (pos_y) - 25);
}

