#ifndef __molecule_h__
#define __molecule_h__

typedef enum {h2o, h, oh} ion_types;
typedef enum {straight, lineair, circles, wave} pattern_types;

class molecule {
 private:
  float pos_x;
  float pos_y;
  int size;
  float direction;
  ion_types ion;
  pattern_types pattern;
  float pattern_cycle;
  float speed;
  float delta;
  bool visible;
 public:
  molecule ();
  void set_molecule (ion_types new_ion, int level);
  void set_delta (float new_delta);
  void game_cycle ();
  void draw (BITMAP * output);
  int get_pos_x ();
  int get_pos_y ();
  int get_size ();
  ion_types get_ion ();
  bool get_visible ();
};

extern BITMAP * h_ionbmp;
extern BITMAP * oh_ionbmp;
extern int molecules_count;
extern int molecules_max;
extern int molecules_step;
extern molecule * molecules;

extern void init_molecule ();
extern void add_molecule (int level);
extern void set_delta_molecules (float new_delta);
extern void game_cycle_molecules ();
extern void draw_molecules (BITMAP *output);
extern void destroy_molecules ();

extern float random (float max_random);

#endif
