#ifndef __ship_h__
#define __ship_h__
#include "molecule.h"

extern BITMAP * nano_ship;

extern void init_ship ();

class ship {
 private:
  float pos_x;
  float pos_y;
  float speed_x;
  float speed_y;
  int size;
  short int h_ions;
  short int oh_ions;
  int h2o_molecules;
  float health;
  float delta;
 public:
  ship ();
  void init ();
  void accelerate_up ();
  void accelerate_down ();
  void accelerate_left ();
  void accelerate_right ();
  void collected_h_ion ();
  void collected_oh_ion ();
  void set_delta (float new_delta);
  void game_cycle ();
  bool test_collision (molecule test_molecule);
  void draw (BITMAP *output);
  int get_health ();
  int get_h_ions ();
  int get_oh_ions ();
  int get_h2o_molecules ();
  int get_pos_x ();
  int get_pos_y ();
  void cheat ();
};

#endif
